VERSION 5.00
Object = "{6B7E6392-850A-101B-AFC0-4210102A8DA7}#1.3#0"; "COMCTL32.OCX"
Begin VB.Form frmMain 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "Knotons Zip and Unzip utility (Beta)"
   ClientHeight    =   2550
   ClientLeft      =   45
   ClientTop       =   615
   ClientWidth     =   8715
   Icon            =   "frmMain.frx":0000
   LinkTopic       =   "frmMain"
   MaxButton       =   0   'False
   ScaleHeight     =   2550
   ScaleWidth      =   8715
   StartUpPosition =   2  'CenterScreen
   Begin ComctlLib.ListView lvwZip 
      Height          =   2055
      Left            =   0
      TabIndex        =   2
      Top             =   60
      Width           =   8715
      Visible         =   0   'False
      _ExtentX        =   15372
      _ExtentY        =   3625
      View            =   3
      LabelEdit       =   1
      MultiSelect     =   -1  'True
      LabelWrap       =   0   'False
      HideSelection   =   0   'False
      _Version        =   327682
      ForeColor       =   -2147483640
      BackColor       =   -2147483643
      BorderStyle     =   1
      Appearance      =   1
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Tahoma"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      NumItems        =   0
   End
   Begin VB.ListBox Dir1 
      Height          =   2010
      Left            =   0
      TabIndex        =   1
      Top             =   60
      Width           =   8655
      Visible         =   0   'False
   End
   Begin VB.Line Line1 
      X1              =   0
      X2              =   8700
      Y1              =   0
      Y2              =   0
   End
   Begin VB.Label lblZipFile 
      Height          =   315
      Left            =   6780
      TabIndex        =   3
      Top             =   120
      Width           =   1935
      Visible         =   0   'False
   End
   Begin VB.Label Label1 
      Height          =   375
      Left            =   60
      TabIndex        =   0
      Top             =   2160
      Width           =   8595
   End
   Begin VB.Menu mnuFile 
      Caption         =   "File"
      Begin VB.Menu mnuOpen 
         Caption         =   "Open Zip Archive"
      End
   End
   Begin VB.Menu mnuAdd 
      Caption         =   "Add"
      Begin VB.Menu mnuAddDir 
         Caption         =   "Add Directory"
      End
      Begin VB.Menu mnuAddFiles 
         Caption         =   "Add Files"
      End
   End
   Begin VB.Menu mnuAction 
      Caption         =   "Action"
      Begin VB.Menu mnuExtract 
         Caption         =   "Extract to"
      End
      Begin VB.Menu mnuCompress 
         Caption         =   "Compress to"
      End
   End
   Begin VB.Menu mnuSettings 
      Caption         =   "Settings"
   End
End
Attribute VB_Name = "frmMain"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Public WithEvents myZip As cZip
Attribute myZip.VB_VarHelpID = -1
Public WithEvents myUnZip As cUnzip
Attribute myUnZip.VB_VarHelpID = -1
Private tmpPass As String
Private CD As CommonDialog
Private blnFolders As Boolean
Private strBaseDir As String
Private Declare Function LockWindowUpdate Lib "user32" (ByVal hwndLock As Long) As Long

Private Sub Form_Load()
Set myZip = New cZip
Set myUnZip = New cUnzip
Set CD = New CommonDialog

With lvwZip.ColumnHeaders
    .Add , , "Filename", 160 * Screen.TwipsPerPixelX
    .Add , , "Size", 32 * Screen.TwipsPerPixelX
    .Add , , "Packed", 32 * Screen.TwipsPerPixelX
    .Add , , "Modified", 96 * Screen.TwipsPerPixelX
    .Add , , "Directory", 160 * Screen.TwipsPerPixelX
End With

End Sub

Private Sub mnuAddDir_Click()
Dim i As Integer
Dim tmp As String, tmp2 As String
lvwZip.ListItems.Clear
Dir1.Clear
strBaseDir = ""
tmp = CD.GetFolderName("Choose directory to compress")
If tmp <> "" Then
    Me.MousePointer = vbHourglass
    LockWindowUpdate Dir1.hWnd
    strBaseDir = tmp
    Dir1.AddItem Replace(strBaseDir & "\", "\\", "\")
    lvwZip.Visible = False
    Dir1.Visible = True
    ListSubDir tmp
    blnFolders = True
    LockWindowUpdate 0&
    Me.MousePointer = vbDefault
End If
End Sub

Private Sub mnuAddFiles_Click()
Dim tmp As String, DirPath As String
Dim mFiles As Variant
Dim i As Integer
blnFolders = False
CD.Filter = "All Files (*.*)|*.*"
CD.DialogTitle = "Select Files"
CD.AllowMultiSelect = True
CD.ShowOpen
mFiles = CD.FileName
If IsArray(mFiles) Then
    lvwZip.Visible = False
    Dir1.Visible = True
    tmp = mFiles(1)
    mFiles(1) = mFiles(UBound(mFiles))
    mFiles(UBound(mFiles)) = tmp
    DirPath = mFiles(0) & "\"
    DirPath = Replace(DirPath, "\\", "\")
    For i = 1 To UBound(mFiles)
        Dir1.AddItem DirPath & mFiles(i)
    Next
Else
    If mFiles <> "" Then
        lvwZip.Visible = False
        Dir1.Visible = True
        DirPath = Mid(mFiles, 1, InStrRev(mFiles, "\"))
        DirPath = Replace(DirPath, "\\", "\")
        ReDim Check(0)
        Dir1.AddItem DirPath & Mid(mFiles, InStrRev(mFiles, "\") + 1)
    End If
End If
End Sub

Private Sub mnuCompress_Click()
Dim i As Integer
Dim tmp As String

If Dir1.ListCount > 0 Then
    CD.Filter = "Zip Files (*.zip)|*.zip"
    CD.DialogTitle = "Choose name for the compressed file"
    CD.ShowSave
    tmp = CD.FileName
    
    If tmp <> "" Then
        Me.MousePointer = vbHourglass
        If EncryptPass <> "" Then myZip.Encrypt = True
        
        If blnFolders Then
            myZip.BasePath = Mid(strBaseDir, 1, InStrRev(strBaseDir, "\"))
            myZip.StoreFolderNames = True
        End If
        
        
        
        For i = 0 To Dir1.ListCount - 1
            If blnFolders Then
                myZip.AddFileSpec Replace(Dir1.List(i), myZip.BasePath & "\", "") & "*.*"
            Else
                myZip.AddFileSpec Dir1.List(i)
            End If
        Next
        
        myZip.ZipFile = tmp
        myZip.Zip
        Me.MousePointer = vbDefault
        
        If myZip.Success Then
            MsgBox "Compressing is successfully done", vbInformation
        Else
            MsgBox "Compressing failed!", vbCritical
        End If
        
        Dir1.Clear
        lvwZip.ListItems.Clear
        strBaseDir = ""
    End If
End If
End Sub

Private Sub mnuExtract_Click()
Dim i As Integer
Dim tmp As String
If myUnZip.FileCount > 0 Then
    tmp = CD.GetFolderName("Choose destination")
    If tmp <> "" Then
        Me.MousePointer = vbHourglass
        myUnZip.CaseSensitiveFileNames = True
        myUnZip.PromptToOverwrite = True
        myUnZip.UnzipFolder = tmp
        myUnZip.ZipFile = lblZipFile.Caption
        myUnZip.UseFolderNames = True
        For i = 1 To myUnZip.FileCount
            myUnZip.FileSelected(i) = True
        Next
        myUnZip.Unzip
        Me.MousePointer = vbDefault
        MsgBox "Done"
        lblZipFile.Caption = ""
        Dir1.Clear
        lvwZip.ListItems.Clear
    End If
End If
End Sub

Private Sub mnuOpen_Click()
Dim tmp As String
lvwZip.ListItems.Clear
Dir1.Clear
myZip.ClearFileSpecs
CD.AllowMultiSelect = False
CD.Filter = "Zip Files (*.zip)|*.zip"
CD.ShowOpen
tmp = CD.FileName
If tmp <> "" Then
    lvwZip.Visible = True
    Dir1.Visible = False
    Call pOpen(tmp)
End If
lblZipFile.Caption = tmp

End Sub

Private Sub mnuSettings_Click()
frmEncryption.Show
End Sub

Private Sub myUnZip_OverwritePrompt(ByVal sFile As String, eResponse As EUZOverWriteResponse)
Dim frm As New frmOverwrite
With frm
    frm.TheCaption = "Do you want to overwrite " & sFile & "?"
    frm.Show vbModal, Me
    If frm.Response = vbYes Then
        If frm.ApplyToAll Then
            eResponse = euzOverwriteAllFiles
        Else
            eResponse = euzOverwriteThisFile
        End If
    ElseIf frm.Response = vbNo Then
        If frm.ApplyToAll Then
            eResponse = euzDoNotOverwrite
        Else
            eResponse = euzOverwriteNone
        End If
    Else
        eResponse = euzOverwriteNone
    End If
End With

End Sub


Private Sub myUnZip_PasswordRequest(sPassword As String, bCancel As Boolean)
Dim frm As New frmPassword
With frm
    .Show vbModal, Me
    If Not frm.Cancelled Then
        sPassword = frm.Password
    Else
        bCancel = True
    End If
End With
End Sub

Private Sub myUnZip_Progress(ByVal lCount As Long, ByVal sMsg As String)
Label1.Caption = sMsg
DoEvents
End Sub

Private Sub myZip_PasswordRequest(sPassword As String, ByVal lMaxPasswordLength As Long, ByVal bConfirm As Boolean, bCancel As Boolean)
Dim sPass As String
Dim sMsg As String
sPassword = EncryptPass
End Sub

Private Sub myZip_Progress(ByVal lCount As Long, ByVal sMsg As String)
Label1.Caption = sMsg
DoEvents
End Sub

Public Function ListSubDir(ByVal Path As String)
Dim strDirs As Variant, Obj As clsGetDirectories
Dim lngCount As Long
Dim i As Long
Set Obj = New clsGetDirectories
strDirs = Obj.GetDirs(Path)
lngCount = UBound(strDirs)

For i = 0 To lngCount
    Dir1.AddItem strDirs(i)
Next

End Function

Private Function pOpen(ByVal sFile As String) As Boolean
Dim i As Long
Dim itmX As ListItem

lvwZip.ListItems.Clear

' Get the file directory:
myUnZip.ZipFile = sFile
myUnZip.Directory

LockWindowUpdate lvwZip.hWnd
' Display it in the ListView:
For i = 1 To myUnZip.FileCount
   sFile = myUnZip.FileName(i)
    If myUnZip.FileEncrypted(i) Then sFile = sFile & "+"
    Set itmX = lvwZip.ListItems.Add(, "File" & i, sFile)
    itmX.SubItems(1) = myUnZip.FileSize(i)
    itmX.SubItems(2) = myUnZip.FilePackedSize(i)
    itmX.SubItems(3) = Format$(myUnZip.FileDate(i), "YYYY-MM-DD") & " " & Format$(myUnZip.FileDate(i), "HH:MM")
    itmX.SubItems(4) = myUnZip.FileDirectory(i)
Next i
LockWindowUpdate 0&
End Function

